VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cCyloid"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Class Name:   cCycloid.cls  "Cycloid Class"
'Author:       Ben Baker  <headspin@iinet.net.au>
'Version:      1.0 [14 / July / 2004]
'
'
'Leagal:
'        Redistribution of this code, whole or in part, as source code or in binary form, alone or
'        as part of a larger distribution or product, is forbidden for any commercial or for-profit
'        use without the author's explicit written permission.
'
'        Redistribution of this code, as source code or in binary form, with or without
'        modification, is permitted provided that the following conditions are met:
'
'        Redistributions of source code must include this list of conditions, and the following
'        acknowledgment:
'
'        This product includes code developed by Ben Baker.  <headspin@iinet.net.au>
'        Source code, written in Visual Basic, is freely available for non-commercial,
'        non-profit use at www.planetsourcecode.com.
'
'        Redistributions in binary form, as part of a larger project, must include the above
'        acknowledgment in the end-user documentation.  Alternatively, the above acknowledgment
'        may appear in the software itself, if and wherever such third-party acknowledgments
'        normally appear.
'
'
'Credits:
'        Hypocycloid movement by Markus Eichler "me2222" post@neuemedienkunst.de www.neuemedienkunst.de
'
'
'Description:  This class will create hypoclycloidal movement
'
'Dependencies: None
'

Private SinTable(0 To 90) As Double
Private rr As Single, re As Single, a As Single, phi As Single, z As Single
Private Angle As Double, myAngle As Double
Private Quad As Integer

Private Function SinCalc() As Double
    If myAngle - Fix(myAngle) >= 0.5 Then
        myAngle = Fix(myAngle) + 1
    Else
        myAngle = Fix(myAngle)
    End If
    SinCalc = SinTable(myAngle)
End Function

Private Function GetSin() As Double
    myAngle = Angle
    Dim Sin As Double
    SetAngle
    Sin = SinCalc
    If Quad = 3 Or Quad = 4 Then
        GetSin = -Sin
    Else
        GetSin = Sin
    End If
End Function

Private Function GetCos() As Double
    Dim Sin As Double
    SetAngle
    myAngle = 90 - myAngle
    Sin = SinCalc
    If Quad = 2 Or Quad = 3 Then
        GetCos = -Sin
    Else
        GetCos = Sin
    End If
End Function

Private Sub SetAngle()
    myAngle = Angle
    myAngle = myAngle# - (Fix(myAngle / 360) * 360) ' Overflow
    If (myAngle < 0) Then
        myAngle = myAngle + 360
    End If
    Quad = 1
    If myAngle > 90 And myAngle <= 180 Then
        myAngle = 180 - myAngle
        Quad = 2
    End If
    If myAngle > 180 And myAngle <= 270 Then
        myAngle = myAngle - 180
        Quad = 3
    End If
    If myAngle > 270 And myAngle < 360 Then
        myAngle = 360 - myAngle
        Quad = 4
    End If
End Sub

Public Sub setCyloid(myrr As Single, myre As Single, mya As Single, myphi As Single, myz As Single)
    ' cycle params
    rr = myrr
    re = myre
    a = mya
    ' starting angle
    phi = myphi
    ' smoothness of movement (amount of angle increase)
    z = myz
    Angle = 0
    Quad = 0
End Sub

Public Function getCyloidXY(ByRef x As Single, ByRef y As Single)
    Dim wert1 As Double, wert2 As Double
    phi = phi + z
    'x
    Angle = phi
    wert1 = GetCos * (rr - re)
    Angle = ((rr - re) / re * phi)
    wert2 = GetCos * a
    x = wert1 + wert2
    ' y
    Angle = phi
    wert1 = GetSin * (rr - re)
    Angle = ((rr - re) / re * phi)
    wert2 = GetSin * a
    y = wert1 - wert2
End Function

Private Sub InitSinTable()
    SinTable(0) = 0#
    SinTable(1) = 0.017452
    SinTable(2) = 0.034899
    SinTable(3) = 0.052336
    SinTable(4) = 0.069756
    SinTable(5) = 0.087156
    SinTable(6) = 0.104528
    SinTable(7) = 0.121869
    SinTable(8) = 0.139173
    SinTable(9) = 0.156434
    SinTable(10) = 0.173648
    SinTable(11) = 0.1908
    SinTable(12) = 0.2079
    SinTable(13) = 0.225
    SinTable(14) = 0.2419
    SinTable(15) = 0.2588
    SinTable(16) = 0.2756
    SinTable(17) = 0.2924
    SinTable(18) = 0.309
    SinTable(19) = 0.3256
    SinTable(20) = 0.34202
    SinTable(21) = 0.3584
    SinTable(22) = 0.3746
    SinTable(23) = 0.3907
    SinTable(24) = 0.4067
    SinTable(25) = 0.4226
    SinTable(26) = 0.4384
    SinTable(27) = 0.454
    SinTable(28) = 0.4695
    SinTable(29) = 0.4848
    SinTable(30) = 0.5
    SinTable(31) = 0.515
    SinTable(32) = 0.5299
    SinTable(33) = 0.5446
    SinTable(34) = 0.5592
    SinTable(35) = 0.5736
    SinTable(36) = 0.5878
    SinTable(37) = 0.6018
    SinTable(38) = 0.6157
    SinTable(39) = 0.6293
    SinTable(40) = 0.642788
    SinTable(41) = 0.6561
    SinTable(42) = 0.6691
    SinTable(43) = 0.682
    SinTable(44) = 0.6947
    SinTable(45) = 0.7071
    SinTable(46) = 0.7193
    SinTable(47) = 0.7314
    SinTable(48) = 0.7431
    SinTable(49) = 0.7547
    SinTable(50) = 0.766044
    SinTable(51) = 0.7771
    SinTable(52) = 0.788
    SinTable(53) = 0.7986
    SinTable(54) = 0.809
    SinTable(55) = 0.8192
    SinTable(56) = 0.829
    SinTable(57) = 0.8387
    SinTable(58) = 0.848
    SinTable(59) = 0.8572
    SinTable(60) = 0.866025
    SinTable(61) = 0.8746
    SinTable(62) = 0.8829
    SinTable(63) = 0.891
    SinTable(64) = 0.8988
    SinTable(65) = 0.9063
    SinTable(66) = 0.9135
    SinTable(67) = 0.9205
    SinTable(68) = 0.9272
    SinTable(69) = 0.9336
    SinTable(70) = 0.939693
    SinTable(71) = 0.9455
    SinTable(72) = 0.9511
    SinTable(73) = 0.9563
    SinTable(74) = 0.9613
    SinTable(75) = 0.9659
    SinTable(76) = 0.9703
    SinTable(77) = 0.9744
    SinTable(78) = 0.9781
    SinTable(79) = 0.9816
    SinTable(80) = 0.984808
    SinTable(81) = 0.9877
    SinTable(82) = 0.9903
    SinTable(83) = 0.9925
    SinTable(84) = 0.9945
    SinTable(85) = 0.9962
    SinTable(86) = 0.9976
    SinTable(87) = 0.9986
    SinTable(88) = 0.9994
    SinTable(89) = 0.9998
    SinTable(90) = 1#
End Sub

Private Sub Class_Initialize()
    InitSinTable
End Sub
