Attribute VB_Name = "mMessenger"
Option Explicit

Private Type COPYDATASTRUCT
    dwData As Long   ' Use this to identify your message
    cbData As Long   ' Number of bytes to be transferred
    lpData As Long   ' Address of data
End Type

'Copies a block of memory from one location to another.
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SendMessageTimeout Lib "user32" Alias "SendMessageTimeoutA" (ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, lParam As Any, ByVal fuFlags As Long, ByVal uTimeout As Long, lpdwResult As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Private Const GWL_WNDPROC = (-4)

Private Const WM_COPYDATA = &H4A
Private Const WM_SETTEXT = &HC
Private Const WM_GETTEXT = &HD
Private Const WM_COPY = &H301
Private Const WM_PASTE = &H302
Private Const MAX_PATH = 260
Private Const WM_CLOSE = &H10&

Private lpPrevWndProc As Long
Public lHwnd         As Long

Public Sub pHook()
    ' Sub class the form to trap for Windows messages.
    lpPrevWndProc = SetWindowLong(lHwnd, GWL_WNDPROC, AddressOf fWindowProc)
    Debug.Print lpPrevWndProc
End Sub

Sub pReceiveMsg(lParam As Long)
    Dim sString       As String
    Dim l             As Long
    Dim lnumEls       As Long
    Dim bfailed       As Boolean
    Dim pb            As New PropertyBag
    Dim cds           As COPYDATASTRUCT
    Dim buf(1 To 255) As Byte
    
    ' Copy the data sent to this application into a local structure.
    Call CopyMemory(cds, ByVal lParam, Len(cds))
    
    ' Copy the string that was passed into a byte array.
    Call CopyMemory(buf(1), ByVal cds.lpData, cds.cbData)

    ' Convert the ASCII byte array back to a Unicode string.
    sString = StrConv(buf, vbUnicode)
    sString = Left$(sString, InStr(1, sString, Chr$(0)) - 1)
    ' Display the received string.
    frmScroller.txtReceive = CStr(cds.dwData) & sString
    
    If bfailed Then
        Call MsgBox("Data transferred incorrectly", vbExclamation, "Error Receiving Data")
    End If
End Sub

Public Sub pUnhook()
    ' Remove the subclassing.
    Call SetWindowLong(lHwnd, GWL_WNDPROC, lpPrevWndProc)
End Sub

Function fWindowProc(ByVal hw As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    ' This callback routine is called by Windows whenever
    ' a message is sent to this form.  If it is the copy
    ' message call our procedure to receive the message.
    
    If uMsg = WM_COPYDATA Then Call pReceiveMsg(lParam)
    
    ' Call the original window procedure associated with this form.
    fWindowProc = CallWindowProc(lpPrevWndProc, hw, uMsg, wParam, lParam)
End Function

Public Sub SendData(lSendHwnd As Long, txtString As String)
    Dim sString As String
    Dim cds     As COPYDATASTRUCT
    Dim buf(1 To 255) As Byte
    
    sString = Trim$(txtString)
    If sString = "" Then Exit Sub

    Call CopyMemory(buf(1), ByVal sString, Len(sString))
    With cds
        .dwData = 1
        .cbData = Len(sString) + 1
        .lpData = VarPtr(buf(1))
    End With

    Call SendMessage(lSendHwnd, WM_COPYDATA, lHwnd, cds)
End Sub


