Attribute VB_Name = "mDXScroller"
Option Explicit

Private Type WNDCLASS
    style As Long
    lpfnwndproc As Long
    cbClsextra As Long
    cbWndExtra As Long
    hInstance As Long
    hIcon As Long
    hCursor As Long
    hbrBackground As Long
    lpszMenuName As String
    lpszClassName As String
End Type

Private Type POINT
    x As Long
    y As Long
End Type

Private Type size
    cx As Long
    cy As Long
End Type

Private Type POINTAPI
   x As Long
   y As Long
End Type

Private Type MSG
   hwnd     As Long        'window where message occured
   Message  As Long        'message id itself
   wParam   As Long        'further defines message
   lParam   As Long        'further defines message
   time     As Long        'time of message event
   pt       As POINTAPI    'position of mouse
End Type

'Font Weight Parameters
Private Enum fntWeight
    FW_HEAVY = 900
    FW_BLACK = FW_HEAVY
    FW_BOLD = 700
    FW_SEMIBOLD = 600
    FW_DEMIBOLD = FW_SEMIBOLD
    FW_DONTCARE = 0
    FW_EXTRABOLD = 800
    FW_EXTRALIGHT = 200
    FW_LIGHT = 300
    FW_MEDIUM = 500
    FW_NORMAL = 400
    FW_REGULAR = FW_NORMAL
    FW_THIN = 100
    FW_ULTRABOLD = FW_EXTRABOLD
    FW_ULTRALIGHT = FW_EXTRALIGHT
End Enum

'Font Character Sets
Private Enum fntCharSet
    ANSI_CHARSET = 0
    DEFAULT_CHARSET = 1
    SYMBOL_CHARSET = 2
    SHIFTJIS_CHARSET = 128
    HANGEUL_CHARSET = 129
    CHINESEBIG5_CHARSET = 136
    OEM_CHARSET = 255
End Enum

'Font Output Precis
Private Enum fntOutPrecis
    OUT_CHARACTER_PRECIS = 2
    OUT_DEFAULT_PRECIS = 0
    OUT_DEVICE_PRECIS = 5
    OUT_OUTLINE_PRECIS = 8
    OUT_RASTER_PRECIS = 6
    OUT_STRING_PRECIS = 1
    OUT_STROKE_PRECIS = 3
    OUT_TT_ONLY_PRECIS = 7
    OUT_TT_PRECIS = 4
End Enum

'Font Clip Precis
Private Enum fntClipPrecis
    CLIP_CHARACTER_PRECIS = 1
    CLIP_DEFAULT_PRECIS = 0
    CLIP_EMBEDDED = 128
    CLIP_LH_ANGLES = 16
    CLIP_MASK = &HF
    CLIP_STROKE_PRECIS = 2
    CLIP_TO_PATH = 4097
    CLIP_TT_ALWAYS = 32
End Enum

'Font Quality
Private Enum fntQuality
    DEFAULT_QUALITY = 0
    PROOF_QUALITY = 2
    DRAFT_QUALITY = 1
End Enum

'Font Pitch
Private Enum fntPitch
    DEFAULT_PITCH = 0
    FIXED_PITCH = 1
    VARIABLE_PITCH = 2
End Enum

'Font Family
Private Enum fntFamily
    FF_DECORATIVE = 80
    FF_DONTCARE = 0
    FF_MODERN = 48
    FF_ROMAN = 16
    FF_SCRIPT = 64
    FF_SWISS = 32
End Enum

'Font Face Size
Private Enum fntFace
    LF_FACESIZE = 32
    LF_FULLFACESIZE = 64
End Enum

Private Const TRANSPARENT = 1
Private Const LOGPIXELSY = 90

Private Declare Function PeekMessage Lib "user32" Alias "PeekMessageA" (lpMsg As MSG, ByVal hwnd As Long, ByVal wMsgFilterMin As Long, ByVal wMsgFilterMax As Long, ByVal wRemoveMsg As Long) As Long
Private Declare Function DispatchMessage Lib "user32" Alias "DispatchMessageA" (lpMsg As MSG) As Long
Private Declare Function TranslateMessage Lib "user32" (lpMsg As MSG) As Long
Private Declare Function GetInputState Lib "user32" () As Long

Private Declare Function MulDiv Lib "kernel32" (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal Height As Long, ByVal Width As Long, ByVal Escapement As Long, ByVal Orientation As Long, ByVal Weight As fntWeight, ByVal Italic As Long, ByVal Underline As Long, ByVal StrikeOut As Long, ByVal CharSet As fntCharSet, ByVal OutputPrecision As fntOutPrecis, ByVal ClipPrecision As fntClipPrecis, ByVal Quality As fntQuality, ByVal PitchAndFamily As Long, ByVal Face As String) As Long
Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function SetBkMode Lib "gdi32.dll" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hwnd As Long, ByVal hdc As Long) As Long

Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function SetCursor Lib "user32" (ByVal hCursor As Long) As Long
Private Declare Function GetTextExtentPoint32 Lib "gdi32" Alias "GetTextExtentPoint32A" (ByVal hdc As Long, ByVal lpsz As String, ByVal cbString As Long, lpSize As size) As Long
Private Declare Function ClientToScreen Lib "user32.dll" (ByVal hwnd As Long, lpPoint As POINT) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Function DefWindowProc Lib "user32.dll" Alias "DefWindowProcA" (ByVal hwnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Sub ZeroMemory Lib "kernel32" Alias "RtlZeroMemory" (Destination As Any, ByVal Length As Long)
Private Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
Private Declare Function RegisterClass Lib "user32" Alias "RegisterClassA" (lpWndClass As WNDCLASS) As Long
Private Declare Function UnregisterClass Lib "user32" Alias "UnregisterClassA" (ByVal lpClassName As Any, ByVal hInstance As Long) As Long
Private Declare Function LoadIcon Lib "user32" Alias "LoadIconA" (ByVal hInstance As Long, ByVal lpIconName As String) As Long
Private Declare Function LoadCursor Lib "user32" Alias "LoadCursorA" (ByVal hInstance As Long, ByVal lpCursorName As String) As Long
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
' Private Declare Function PostQuitMessage Lib "User32" (nExitCode As Long) As Long

Private blnScroller As Boolean

Private Const SZ_NAME = "DXScroller"
Private Const SZ_TITLE = "DXScroller"

Private Const MSG_SCROLLER = 1

Private Const PI As Double = 3.14159265358979 'The definition of PI

Private Const SHADOW_OFFSET = 3

Private Const MAX_SINE = 90

Private Const VK_ESCAPE = &H1B

Private Const MY_WM_QUIT = &HA1     'WM_QUIT in api viewer is wrong this is the right constant
Private Const PM_REMOVE = &H1       'paramater on peekmessage to remove or leave message in queue

Private Const HTCAPTION = 2
Private Const WM_NCLBUTTONDOWN = &HA1

Private Const WM_DESTROY = &H2
Private Const WM_CLOSE = &H10
Private Const WM_SETCURSOR = &H20
Private Const WM_KEYDOWN = &H100
Private Const WM_LBUTTONDOWN = &H201

Private Const SW_SHOWNORMAL As Long = 1

Private Const WS_EX_TOPMOST = &H8
Private Const WS_EX_TOOLWINDOW = &H80
Private Const WS_EX_APPWINDOW = &H40000
Private Const WS_EX_NOACTIVATE = &H8000000
Private Const WS_POPUP = &H80000000

Private Const IDC_ARROW = 32512
Private Const IDI_APPLICATION = 32512

Private Const CS_VREDRAW = &H1
Private Const CS_HREDRAW = &H2

Private lpDX As New DirectX7
Private lpDD As DirectDraw7
Private lpDDSPrimary As DirectDrawSurface7
Private lpDDSOffGFX As DirectDrawSurface7
Private lpDDSSmilie As DirectDrawSurface7
' Private lpDDSTemp As DirectDrawSurface7
'Private lpDDSOffGFXRotate As DirectDrawSurface7
Private lpDDSOffScrollBuffer As DirectDrawSurface7
Private lpDDSBack As DirectDrawSurface7
Private lpClipper As DirectDrawClipper

Private cKEY As DDCOLORKEY

Private xsp As Long

Private str As String
Private strpos As Long
' Private xip As Long, yip As Long
Private sfx As Long

Private gHwnd As Long
Private sine_ix As Long

Private charSize(128) As size ' 96
Private charMax As size

Private tempStr As String

Private iX As Long
Private iY As Long
Private ioffset As Long
Private iwidth As Long
Private iheight As Long

Private SourceRect As RECT
Private DestRect As RECT

Private sineTab(MAX_SINE) As Byte
Private sineTab1(MAX_SINE) As Byte
Private sineTab2(MAX_SINE) As Byte
Private sineTab3(MAX_SINE) As Byte
Private sineTab4(MAX_SINE) As Byte
Private sineTab5(MAX_SINE) As Byte

Public marqueeFont As New StdFont
Public DDmarqueeFont As IFont
Public marqueeColor As Long
Public marqueeText As String
Private m_cM As New cMonitors

Public Function CheckScrollerStatus() As Boolean
    CheckScrollerStatus = blnScroller
End Function

Private Sub MeasureText()
    Dim xdc As Long    ' the working dc
    
    charMax.cx = 0
    charMax.cy = 0
    
    xdc = CreateCompatibleDC(0&)

    If xdc = 0 Then
        Exit Sub
    End If

    Dim hFont As Long
    Dim lfHeight As Long
    
    lfHeight = -MulDiv(marqueeFont.size, GetDeviceCaps(xdc, LOGPIXELSY), 72)

    hFont = CreateFont(lfHeight, _
    0, 0, 0, FW_NORMAL, 0, 0, 0, _
    DEFAULT_CHARSET, OUT_CHARACTER_PRECIS, CLIP_DEFAULT_PRECIS, _
    DEFAULT_QUALITY, DEFAULT_PITCH Or FF_DONTCARE, marqueeFont.Name)

    Dim hold As Long
    hold = SelectObject(xdc, hFont)
    
    ' SetTextColor xdc, marqueeColor
       
    ' Output text to screen
    ' TextOut xdc, 0, 0, "A", 1

    Dim n As Long
    For n = 32 To 127 Step 1
        GetTextExtentPoint32 xdc, Chr(n), 1, charSize(n) ' n + 32 frmScroller.pbTextMeasure.hDC
        If charSize(n).cx > charMax.cx Then charMax.cx = charSize(n).cx
        If charSize(n).cy > charMax.cy Then charMax.cy = charSize(n).cy
    Next n
    
    For n = 1 To 31 Step 1
        charSize(n).cx = charMax.cx
        charSize(n).cy = charMax.cy
    Next n

    hFont = SelectObject(xdc, hold)

    DeleteObject hFont
    
    DeleteDC xdc
End Sub

Private Sub CalcPosition()
    Dim MyMonitor As cMonitor
   
    Set MyMonitor = m_cM.Monitor(frmScroller.cboMonitors.ItemData(frmScroller.cboMonitors.ListIndex))
    
    ioffset = CLng((frmScroller.vsbPosition.Value / frmScroller.vsbPosition.Max) * MyMonitor.Height)
    If (ioffset + iheight > MyMonitor.Height) Then
        ioffset = MyMonitor.Height - iheight
    End If
    
    iX = MyMonitor.left
    iY = MyMonitor.top + ioffset

    iwidth = MyMonitor.Width
    iheight = (charMax.cy * 2) ' Make room for sinewaves
    Debug.Print CStr(iheight)
End Sub

Public Function MoveScroller()
    Call CalcPosition
    MoveWindow gHwnd, iX, iY, iwidth, iheight, True
    Call doRect
End Function

Private Function GetFuncAddress(ByVal Address As Long) As Long
   GetFuncAddress = Address
End Function

Function WindowProc(ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Select Case wMsg
        Case WM_SETCURSOR
            SetCursor (0&) ' Turn off the mouse cursor
        Case WM_KEYDOWN
            Select Case wParam
                Case VK_ESCAPE
                    blnScroller = False
                    Call CloseScroller
                Case 49 ' 1
                Case 50 ' 2
                Case 51 ' 3
                Case 77 ' 'M'
            End Select
        Case WM_LBUTTONDOWN
            ' SendMessage hwnd, WM_NCLBUTTONDOWN, HTCAPTION, 0&
            ' Call MoveScroller
        Case WM_DESTROY
            blnScroller = False
            Call ReleaseObjects
            ' PostQuitMessage 0&
    End Select
        
    ' Call the original window procedure associated with this form.
    WindowProc = DefWindowProc(hwnd, wMsg, wParam, lParam)
End Function

Private Sub doRect()
    ZeroMemory DestRect, Len(DestRect)

    ' get the client area
    GetClientRect gHwnd, DestRect

    ' copy the rect's data into two points
    Dim p1 As POINT
    Dim p2 As POINT

    p1.x = DestRect.left
    p1.y = DestRect.top
    p2.x = DestRect.right
    p2.y = DestRect.bottom

    ' convert it to screen coordinates (like DirectDraw uses)
    ClientToScreen gHwnd, p1
    ClientToScreen gHwnd, p2

    ' copy the two points' data back into the rect
    DestRect.left = p1.x
    DestRect.top = p1.y
    DestRect.right = p2.x
    DestRect.bottom = p2.y
End Sub

' Initalize DirectDraw.
Private Sub InitDXWindow()
    Dim wc As WNDCLASS
    Dim ddsd As DDSURFACEDESC2
    Dim hr As Long

    With wc
        .style = CS_HREDRAW Or CS_VREDRAW
        .lpfnwndproc = GetFuncAddress(AddressOf WindowProc)
        .cbClsextra = 0
        .cbWndExtra = 0
        .hInstance = App.hInstance
        .hIcon = LoadIcon(App.hInstance, IDI_APPLICATION)
        .hCursor = LoadCursor(0&, IDC_ARROW)
        .hbrBackground = 0&
        .lpszMenuName = SZ_NAME
        .lpszClassName = SZ_TITLE
    End With
    RegisterClass wc

    gHwnd = CreateWindowEx( _
        WS_EX_TOPMOST Or WS_EX_TOOLWINDOW Or WS_EX_NOACTIVATE And Not WS_EX_APPWINDOW, _
        SZ_NAME, _
        SZ_TITLE, _
        WS_POPUP, _
        iX, iY, _
        iwidth, _
        iheight, _
        0&, _
        0&, _
        App.hInstance, _
        0&)

    If gHwnd = 0 Then
         MsgBox ("Couldn't create window")
         GoTo Error
     End If

    ' Create the DirectDraw object and set cooperative level.
    ' Set lpDX = New DirectX7
    Set lpDD = lpDX.DirectDrawCreate("") ' 0&, lpDD, 0&

    If lpDD Is Nothing Then
         MsgBox ("Couldn't create DirectDraw object")
         GoTo Error
    End If

    ' Set exclusive mode
    lpDD.SetCooperativeLevel gHwnd, DDSCL_NORMAL
    If lpDD Is Nothing Then
        MsgBox ("Couldn't set cooperative level.")
        GoTo Error
    End If

    ' Create the primary surface
    ZeroMemory ddsd, Len(ddsd)
    
    ddsd.lFlags = DDSD_CAPS
    ddsd.ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE
    ddsd.lWidth = iwidth
    ddsd.lHeight = iheight

    ' A call to CreateSurface to create front and back buffers
    Set lpDDSPrimary = lpDD.CreateSurface(ddsd)
    If lpDDSPrimary Is Nothing Then
         MsgBox ("Couldn't create primary surface.")
    End If

    ' Create a clipper to ensure our drawing stays in our window
    Set lpClipper = lpDD.CreateClipper(0)
    If lpClipper Is Nothing Then
         GoTo Error
    End If

    ' Setting it to our hwnd gives the clipper the coordinates from our window
    lpClipper.SetHWnd (gHwnd)
    If lpClipper Is Nothing Then
        GoTo Error
    End If

    ' Attach the clipper to the primary surface
    lpDDSPrimary.SetClipper lpClipper
    If lpDDSPrimary Is Nothing Then
        GoTo Error
    End If

    ' Create back buffer
    ZeroMemory ddsd, Len(ddsd)
    ddsd.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH
    ddsd.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN

    ' Create graphics surface
    ddsd.lWidth = iwidth
    ddsd.lHeight = iheight
    Set lpDDSBack = lpDD.CreateSurface(ddsd)
    If lpDDSBack Is Nothing Then
       MsgBox ("Couldn't find the back buffer.")
       GoTo Error
    End If

    ZeroMemory ddsd, Len(ddsd)
    ddsd.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH
    ddsd.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN

    ' Create graphics surface
    ddsd.lWidth = charMax.cx + SHADOW_OFFSET
    ddsd.lHeight = charMax.cy + SHADOW_OFFSET
    Set lpDDSOffGFX = lpDD.CreateSurface(ddsd)
    If lpDDSOffGFX Is Nothing Then
        MsgBox ("Couldn't create offscreen graphics surface.")
        GoTo Error
    End If

    lpDDSOffGFX.SetFontTransparency True
    lpDDSOffGFX.SetForeColor marqueeColor
    lpDDSOffGFX.setFont marqueeFont

    'ZeroMemory ddsd, Len(ddsd)
    'ddsd.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH
    'ddsd.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN

    ' Create graphics surface
    'ddsd.lWidth = charMax.cx
    'ddsd.lHeight = charMax.cy
    'Set lpDDSTemp = lpDD.CreateSurface(ddsd)
    'If lpDDSTemp Is Nothing Then
    '    MsgBox ("Couldn't create offscreen graphics surface.")
    '    GoTo Error
    'End If

    'cKEY.low = rgb(1, 1, 1)
    'cKEY.high = rgb(1, 1, 1) ' marqueeColor
    'lpDDSTemp.SetColorKey DDCKEY_SRCBLT, cKEY

    'lpDDSTemp.SetFontTransparency True
    'lpDDSTemp.SetForeColor marqueeColor
    'lpDDSTemp.setFont marqueeFont
    
    ZeroMemory ddsd, Len(ddsd)
    ddsd.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH
    ddsd.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN

    ' Create graphics surface
    ddsd.lWidth = 320 ' 896 / 320 / 324
    ddsd.lHeight = 16 ' 64 / 16 / 18
    Set lpDDSSmilie = lpDD.CreateSurfaceFromFile(App.Path & "\smilies\smilies.bmp", ddsd)
    ' Set lpDDSSmilie = lpDD.CreateSurfaceFromResource("", "101", ddsd)
    If lpDDSSmilie Is Nothing Then
        MsgBox ("Couldn't create offscreen graphics surface.")
        GoTo Error
    End If
    
    cKEY.low = rgb(1, 1, 1)
    cKEY.high = rgb(1, 1, 1)
    lpDDSSmilie.SetColorKey DDCKEY_SRCBLT, cKEY

    ' Create graphics surface
    'ddsd.lWidth = charMax.cx
    'ddsd.lHeight = charMax.cy
    'Set lpDDSOffGFXRotate = lpDD.CreateSurface(ddsd)
    'If lpDDSOffGFXRotate Is Nothing Then
    '    MsgBox ("Couldn't create offscreen graphics surface.")
    '    GoTo Error
    'End If

    ' Create the offscreen scroll buffer
    ddsd.lWidth = iwidth
    ddsd.lHeight = iheight
    Set lpDDSOffScrollBuffer = lpDD.CreateSurface(ddsd)
    If lpDDSOffScrollBuffer Is Nothing Then
        MsgBox ("Couldn't create offscreen scroll surface.")
        GoTo Error
    End If
    
    Call doRect

    clearscreen rgb(0, 0, 0)
    clearSurfaceArea lpDDSPrimary, rgb(0, 0, 0), 0, 0, iwidth, iheight
    clearSurfaceArea lpDDSOffGFX, rgb(0, 0, 0), 0, 0, charMax.cx, charMax.cy
    clearSurfaceArea lpDDSOffScrollBuffer, rgb(0, 0, 0), 0, 0, iwidth, iheight
    Exit Sub
Error:
    blnScroller = False
    Call CloseScroller
End Sub

Private Sub FastDoEvents()
    Dim TMsg As MSG         'holds message recieved from queue
    If PeekMessage(TMsg, 0, 0, 0, PM_REMOVE) Then        'checks for a message in the queue and removes it if there is one
       TranslateMessage TMsg                             'translates the message(dont need if there is no menu)
       DispatchMessage TMsg                              'dispatches the message to be handled
       'If (TMsg.Message = MY_WM_QUIT) Then               'if the message is to quit then exit the loop
       '   Exit Sub
       'End If
    End If
End Sub

Public Sub StartScroller()
    blnScroller = False
    strpos = 0
    xsp = 0

    Call MeasureText
    Call CalcPosition
    Call InitTables
    Call InitDXWindow
    ShowWindow gHwnd, SW_SHOWNORMAL
    str = marqueeText & frmScroller.getPickup
    tempStr = Mid(str, strpos + 1, 1)
    Call MainLoop
End Sub

Private Sub update_display()
    Call doScroll
    Call Sleep(CLng(frmScroller.sldSpeed.Value))
    
    ' If there is a keypress or button click then DoEvents
    ' If GetInputState <> 0 Then DoEvents
    ' DoEvents
    Call FastDoEvents
End Sub

Private Sub MainLoop()
    Randomize
    blnScroller = True
    sfx = frmScroller.cboSfx.ListIndex
    Do While blnScroller
        Call FastFlip
        Call update_display
    Loop
End Sub

Private Sub ReleaseObjects()
    Set lpClipper = Nothing
    Set lpDDSOffScrollBuffer = Nothing
    Set lpDDSSmilie = Nothing
    ' Set lpDDSTemp = Nothing
    Set lpDDSOffGFX = Nothing
    'Set lpDDSOffGFXRotate = Nothing
    Set lpDDSPrimary = Nothing
    Set lpDD = Nothing
    Set lpDX = Nothing
End Sub

Public Sub CloseScroller()
    Call ReleaseObjects
    SendMessage gHwnd, WM_CLOSE, 0&, 0&
    Call UnregisterClass(SZ_NAME, App.hInstance)
End Sub

Private Function DrawGDIText(ByRef text As String, x As Long, y As Long, fontname As String, size As Long, color As Long, ByRef lpdds As DirectDrawSurface7, Optional ByVal Trans = True) As Long
    ' for color use the RGB(r,g,b) macro
    Dim xdc As Long ' the working dc

    ' Get the device context to draw text
    xdc = lpdds.GetDC
    
    If xdc = 0 Then
        DrawGDIText = 0
        Exit Function
    End If
    
    Dim hFont As Long
    Dim lfHeight As Long
    
    lfHeight = -MulDiv(size, GetDeviceCaps(xdc, LOGPIXELSY), 72)

    hFont = CreateFont(lfHeight, _
    0, 0, 0, FW_NORMAL, 0, 0, 0, _
    DEFAULT_CHARSET, OUT_CHARACTER_PRECIS, CLIP_DEFAULT_PRECIS, _
    DEFAULT_QUALITY, DEFAULT_PITCH Or FF_DONTCARE, fontname)

    Dim hold As Long
    hold = SelectObject(xdc, hFont)
    
    SetTextColor xdc, color
    
    ' set background mode to transparent so black isn't copied
    If Trans Then SetBkMode xdc, TRANSPARENT
    
    ' Output text to screen
    TextOut xdc, x, y, text, 1

    hFont = SelectObject(xdc, hold)

    DeleteObject hFont
    
    lpdds.ReleaseDC (xdc)
   
    DrawGDIText = True
End Function

Private Sub doScroll()
    Dim r As RECT, r2 As RECT
    Dim y As Long
    Dim hr As Long
    'Dim Angle As Long

    If xsp >= charSize(Asc(tempStr)).cx Then
        tempStr = Mid(str, strpos + 1, 1)
        
        If strpos < Len(str) - 1 Then
            strpos = strpos + 1
        Else
            frmScroller.ReplaceSmilies marqueeText
            str = marqueeText & " ... " & frmScroller.getPickup
            SendData frmScroller.hMainWnd, MSG_SCROLLER, "FIN"
            strpos = 0
        End If
        
        clearSurfaceArea lpDDSOffGFX, 0, 0, 0, charMax.cx, charMax.cy
        ' clearSurfaceArea lpDDSTemp, 0, 0, 0, charMax.cx, charMax.cy
        
        ' clearSurfaceArea lpDDSOffGFX, rgb(128, 128, 128), 0, 0, charMax.cx, charMax.cy
        ' clearSurfaceArea lpDDSOffGFXRotate, 0, 0, 0, charMax.cx, charMax.cy
        ' lpDDSOffGFX.SetForeColor rgb(Int(Rnd * 256), Int(Rnd * 256), Int(Rnd * 256))
        'Dim i As Integer
        'For i = 10 To 0 Step -1
        '    lpDDSOffGFX.SetForeColor rgb(255 - ((255 \ 10) * i), 0, 0)
        '    lpDDSOffGFX.DrawText i, i, tempStr, False
        'Next i
       
        If Asc(tempStr) >= 32 Then
            Call drawCopper3
            
            If frmScroller.chkShadow = vbChecked Then
                'lpDDSOffGFX.SetForeColor rgb(0, 0, 0)
                'lpDDSOffGFX.DrawText SHADOW_OFFSET, SHADOW_OFFSET, tempStr, False
                DrawGDIText tempStr, SHADOW_OFFSET, SHADOW_OFFSET, marqueeFont.Name, marqueeFont.size, rgb(0, 0, 0), lpDDSOffGFX
            End If
            
            Select Case Asc(tempStr)
            Case 32 To 47
                'lpDDSOffGFX.SetForeColor rgb(255, 0, 0)
                'lpDDSOffGFX.DrawText 0, 0, tempStr, False
                DrawGDIText tempStr, 0, 0, marqueeFont.Name, marqueeFont.size, rgb(255, 0, 0), lpDDSOffGFX
            Case 48 To 57
                'lpDDSOffGFX.SetForeColor rgb(0, 0, 255)
                'lpDDSOffGFX.DrawText 0, 0, tempStr, False
                DrawGDIText tempStr, 0, 0, marqueeFont.Name, marqueeFont.size, rgb(0, 0, 255), lpDDSOffGFX
            Case Else
                'Call drawCopper2 ' Normal Text
                'lpDDSOffGFX.SetForeColor marqueeColor
                'lpDDSOffGFX.DrawText 0, 0, tempStr, False
                'DrawGDIText tempStr, 0, 0, marqueeFont.Name, marqueeFont.size, rgb(1, 1, 1), lpDDSTemp
                DrawGDIText tempStr, 0, 0, marqueeFont.Name, marqueeFont.size, marqueeColor, lpDDSOffGFX
            End Select
    
            ' lpDDSTemp.DrawText 0, 0, tempStr, False
            'r.left = 0
            'r.top = 0
            'r.bottom = charMax.cy
            'r.right = charMax.cx
            'lpDDSOffGFX.BltFast 0, 0, lpDDSTemp, r, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
        Else
            Call drawCopper4
            r.left = 0
            r.top = 0
            r.bottom = charMax.cy
            r.right = charMax.cx
            r2.left = (Asc(tempStr) - 1) * 16
            r2.top = 0
            r2.bottom = 16
            r2.right = r2.left + 16
            lpDDSOffGFX.Blt r, lpDDSSmilie, r2, DDBLT_WAIT Or DDBLT_KEYSRC
        End If
        
        ' RotateSurface lpDDSOffGFXRotate, lpDDSOffGFX, Angle, 0, 0, -1, charSize(Asc(tempStr) - 32).cx, charSize(Asc(tempStr) - 32).cy
        
        'Angle = Angle + 1
        'If Angle = 360 Then Angle = 0

        xsp = 0
    End If

    ' scroll left
    'r.left = 0
    'r.top = 0
    'r.bottom = charSize(Asc(tempStr)).cy
    'r.right = iwidth - 2
    r2.left = 2
    r2.top = 0
    r2.bottom = charSize(Asc(tempStr)).cy
    r2.right = iwidth
    ' lpDDSOffScrollBuffer.Blt r, lpDDSOffScrollBuffer, r2, DDBLT_WAIT
    hr = lpDDSOffScrollBuffer.BltFast(0, 0, lpDDSOffScrollBuffer, r2, DDBLTFAST_WAIT)

    ' scroll new character part at edge
    'r.left = iwidth - 2
    'r.top = 0
    'r.bottom = charSize(Asc(tempStr)).cy
    'r.right = iwidth
    r2.left = xsp
    r2.top = 0
    r2.bottom = charSize(Asc(tempStr)).cy
    r2.right = r2.left + 2
    xsp = xsp + 2
    
    ' lpDDSOffScrollBuffer.Blt r, lpDDSOffGFX, r2, DDBLT_WAIT
    hr = lpDDSOffScrollBuffer.BltFast(iwidth - 2, 0, lpDDSOffGFX, r2, DDBLTFAST_WAIT)
    
    clearscreen 0
    ' clearscreen rgb(128, 128, 128)
    Call drawCopper
    ' Call drawLines
    
    sfx = frmScroller.cboSfx.ListIndex

    ' add effect by blitting to onscreen area from scroll buffer
    Select Case sfx
    Case 0 ' 0. normal
        r.bottom = charMax.cy
        r.top = 0
        r.right = iwidth
        r.left = 0
        hr = lpDDSBack.BltFast(0, 0, lpDDSOffScrollBuffer, r, DDBLTFAST_WAIT)
    Case 1 ' 1. double line spacing
        Dim n As Long
        y = 0
        For n = 0 To charMax.cy Step 1
            r.bottom = y + 1
            r.top = y
            r.left = 0
            r.right = iwidth
            r2.bottom = n + 1
            r2.top = n
            r2.left = 0
            r2.right = iwidth
            lpDDSBack.Blt r, lpDDSOffScrollBuffer, r2, DDBLT_WAIT
            y = y + 2
        Next n
    Case 2 ' 2. wobbly table
        scrollByTable sineTab
    Case 3 ' 3. bridge
        scrollByTable sineTab1
    Case 4 '  4. hump backed bridge
        scrollByTableOffset sineTab2, 0
    Case 5 ' 5. upside down hump backed bridge
        scrollByTableOffset sineTab3, 0
    Case 6 ' 6. sewer rat sine wave
        scrollByTableOffset sineTab, 0
    Case 7 ' 7. shallow line
        scrollByTableOffset sineTab1, 0
    Case 8 ' 8. sine wave + sine offset
        scrollByTableOffset sineTab5, CLng(sineTab(sine_ix))
        sine_ix = sine_ix + 1
        If sine_ix = MAX_SINE Then
            sine_ix = 0
        End If
    Case 9 ' 9. sine wave + mirror
        scrollByMirror CLng(sineTab(sine_ix))
        sine_ix = sine_ix + 1
        If sine_ix = MAX_SINE Then
            sine_ix = 0
        End If
    Case 10 ' 10. double height
        r.bottom = iheight
        r.top = 0
        r.left = 0
        r.right = iwidth
        r2.bottom = charMax.cy
        r2.top = 0
        r2.left = 0
        r2.right = iwidth
        lpDDSBack.Blt r, lpDDSOffScrollBuffer, r2, DDBLT_WAIT
    Case 11 ' 11. normal and inverted spaced double height
        r.bottom = charMax.cy
        r.top = 0
        r.right = iwidth
        r.left = 0
        hr = lpDDSBack.BltFast(0, 0, lpDDSOffScrollBuffer, r, DDBLTFAST_WAIT)
        y = charMax.cy + (2 * charMax.cy)
        For n = 0 To charSize(Asc(tempStr)).cy Step 1
            r.bottom = y + 1
            r.top = y
            r.left = 0
            r.right = iwidth
            r2.bottom = n + 1
            r2.top = n
            r2.left = 0
            r2.right = iwidth
            lpDDSBack.Blt r, lpDDSOffScrollBuffer, r2, DDBLT_WAIT
            y = y - 2
        Next n
    Case 12 ' 12. uphill
        scrollByTableDouble sineTab4
    End Select
End Sub

Private Sub scrollByMirror(offset As Long)
    Dim r As RECT, r2 As RECT
    ' cleararea rgb(0, 0, 0), 0, 0, iwidth, iheight
    Dim n As Long

    r.top = offset
    r.bottom = r.top + charMax.cy
    r.left = 0
    r.right = iwidth
    r2.bottom = charMax.cy
    r2.top = 0
    r2.left = 0
    r2.right = iwidth
    lpDDSBack.Blt r, lpDDSOffScrollBuffer, r2, DDBLT_WAIT

    r.top = r.top + charMax.cy
    r.bottom = r.top + 1
    r2.top = r2.top + charMax.cy
    r2.bottom = r2.top + 1
    For n = 0 To charMax.cy Step 1
        lpDDSBack.Blt r, lpDDSOffScrollBuffer, r2, DDBLT_WAIT
        r2.top = r2.top - 1
        r2.bottom = r2.bottom - 1
        r.top = r.top + 1
        r.bottom = r.bottom + 1
    Next n
End Sub

Private Sub scrollByTableOffset(ByRef yTab() As Byte, offset As Long)
    Dim r As RECT, r2 As RECT
    Dim x As Long, n As Long
    Dim i As Long
    Dim xjump As Long
    x = 0
    n = 0
    xjump = iwidth / MAX_SINE
    ' cleararea rgb(0, 0, 0), 0, 0, iwidth, iheight
    For i = 0 To iwidth / xjump Step 1
        r.top = offset ' + yTab(n)
        r.bottom = r.top + yTab(n) + charMax.cy
        r.left = x
        r.right = x + xjump
        r2.bottom = charMax.cy
        r2.top = 0
        r2.left = x
        r2.right = x + xjump
        lpDDSBack.Blt r, lpDDSOffScrollBuffer, r2, DDBLT_WAIT
        x = x + xjump
        ' If i Mod 4 = 0 Then
            n = n + 1
            If n = MAX_SINE Then n = 0
        ' End If
    Next i
End Sub

Private Sub scrollByTable(ByRef yTab() As Byte)
    Dim r As RECT, r2 As RECT
    Dim x As Long, n As Long
    Dim i As Long
    x = 0
    n = 0
    For i = 0 To iwidth \ 4 Step 1
        r.top = 0 ' yTab(n)
        r.bottom = r.top + yTab(n) + charMax.cy
        r.left = x
        r.right = x + 4
        r2.bottom = charMax.cy
        r2.top = 0
        r2.left = x
        r2.right = x + 4
        lpDDSBack.Blt r, lpDDSOffScrollBuffer, r2, DDBLT_WAIT
        x = x + 4
        ' If i Mod 4 = 0 Then
            n = n + 1
            If n = MAX_SINE Then n = 0
        ' End If
    Next i
End Sub

Private Sub scrollByTableDouble(ByRef yTab() As Byte)
    Dim r As RECT, r2 As RECT
    Dim x As Long, n As Long
    Dim i As Long
    Dim xjump As Long
    xjump = iwidth / MAX_SINE
    x = 0
    n = 0
    For i = 0 To iwidth / xjump Step 1
        r.top = 0 ' yTab(n)
        r.bottom = yTab(n) + charMax.cy
        r.left = x
        r.right = x + xjump
        r2.bottom = charMax.cy
        r2.top = 0
        r2.left = x
        r2.right = x + xjump
        lpDDSBack.Blt r, lpDDSOffScrollBuffer, r2, DDBLT_WAIT
        x = x + xjump
        ' If i Mod 4 = 0 Then
            n = n + 1
            If n = MAX_SINE Then n = 0
        ' End If
    Next i
End Sub

Private Function clearSurfaceArea(ByRef lpdds As DirectDrawSurface7, ByRef rgb As Long, left As Long, top As Long, right As Long, bottom As Long)
    Dim rc As RECT

    rc.top = top
    rc.left = left
    rc.bottom = bottom
    rc.right = right
    lpdds.BltColorFill rc, rgb
End Function

Private Function cleararea(ByRef rgb As Long, left As Long, top As Long, right As Long, bottom As Long)
    Dim rc As RECT
    
    rc.top = top
    rc.left = left
    rc.bottom = bottom
    rc.right = right
    lpDDSBack.BltColorFill rc, rgb
End Function

Private Function clearscreen(ByRef rgb As Long)
    Dim rc As RECT

    lpDDSBack.BltColorFill rc, rgb
End Function

Private Function drawLines()
    Dim y As Single
    Dim r As Single
    Dim dr As Single
    Dim rc As RECT

    dr = -255 / (iheight * Screen.TwipsPerPixelY)
    r = 255
    For y = 0 To (iheight * Screen.TwipsPerPixelY)
        rc.top = y
        rc.left = 0
        rc.bottom = y + 1
        rc.right = iwidth
        lpDDSBack.BltColorFill rc, rgb(r, 0, 0)
        r = r + dr
    Next y
End Function

Private Function drawCopper()
    Dim y As Long
    Dim rc As RECT
    Dim col As Long
    
    col = 255
    
    For y = 0 To iheight Step 1
        rc.top = y
        rc.left = 0
        rc.bottom = y + 1
        rc.right = iwidth
        lpDDSBack.BltColorFill rc, rgb(col, 0, 0)
        col = col - (255 \ iheight)
        If col = 0 Then col = 255
    Next y
End Function

Private Function drawCopper2()
    Dim y As Long
    Dim rc As RECT
    Dim col As Long
    
    col = 128
    
    For y = 0 To charMax.cy Step 1
        rc.top = y
        rc.left = 0
        rc.bottom = y + 1
        rc.right = charMax.cx + SHADOW_OFFSET
        lpDDSOffGFX.BltColorFill rc, rgb(0, col, col)
        col = col + (256 \ charMax.cy)
        If col = 255 Then col = 128
    Next y
End Function

Private Function drawCopper3()
    Dim y As Long
    Dim rc As RECT
    Dim col As Long
    
    col = 255
    
    For y = 0 To charMax.cy Step 1
        rc.top = y
        rc.left = 0
        rc.bottom = y + 1
        rc.right = charMax.cx + SHADOW_OFFSET
        lpDDSOffGFX.BltColorFill rc, rgb(0, col, 0)
        col = col - (255 \ charMax.cy)
        If col = 0 Then col = 255
    Next y
End Function

Private Function drawCopper4()
    Dim y As Long
    Dim rc As RECT
    Dim col As Long
    
    col = 255
    
    For y = 0 To charMax.cy Step 1
        rc.top = y
        rc.left = 0
        rc.bottom = y + 1
        rc.right = charMax.cx + SHADOW_OFFSET
        lpDDSOffGFX.BltColorFill rc, rgb(0, col, 0)
        col = col - (255 \ charMax.cy)
        If col = 0 Then col = 255
    Next y
End Function

Private Sub FastFlip()
    lpDDSPrimary.Blt DestRect, lpDDSBack, SourceRect, DDBLT_WAIT
End Sub

Private Sub Flip()
    ' calculate the client rect in screen coordinates
    Dim drect As RECT
    Dim srect As RECT
    ZeroMemory drect, Len(drect)

    ' get the client area
    GetClientRect gHwnd, drect

    ' copy the rect's data into two points
    Dim p1 As POINT
    Dim p2 As POINT

    p1.x = drect.left
    p1.y = drect.top
    p2.x = drect.right
    p2.y = drect.bottom

    ' convert it to screen coordinates (like DirectDraw uses)
    ClientToScreen gHwnd, p1
    ClientToScreen gHwnd, p2

    ' copy the two points' data back into the rect
    drect.left = p1.x
    drect.top = p1.y
    drect.right = p2.x
    drect.bottom = p2.y

    ' blit the back buffer to our window's position
    ' lpDDSPrimary.BltFast 0, 0, lpDDSBack, &rect, DDBLTFAST_WAIT
    lpDDSPrimary.Blt drect, lpDDSBack, srect, DDBLT_WAIT
End Sub

'--------Function RotateSurface-----
'RotateSurface , takes a surface to rotate, the surface to draw the rotation on, the angle to rotate on,
'the x and y destination to draw on, an optional transparency value
'and optionally it can return the width and height of the surface
Public Function RotateSurface(ByRef surfSource As DirectDrawSurface7, surfDestination As DirectDrawSurface7, lngAngle As Long, XDest As Long, Ydest As Long, Optional rgbTransparency As Long = -1, Optional ByRef Width As Long, Optional ByRef Height As Long)
    Dim ddsdOriginal As DDSURFACEDESC2, ddsdDestination As DDSURFACEDESC2
    Dim iX As Long, iY As Long
    Dim iXDest As Long, iYDest As Long
    Dim rEmpty As RECT, rEmpty2 As RECT
    Dim sngA As Single, SinA As Single, CosA As Single
    Dim dblRMax As Long
    Dim lngXO As Long, lngYO As Long
    Dim lngColor As Long
    Dim lWidth As Long, lHeight As Long
    
    sngA = lngAngle * PI / 180
    SinA = Sin(sngA)
    CosA = Cos(sngA)
    
    surfSource.GetSurfaceDesc ddsdOriginal
    lWidth = ddsdOriginal.lWidth
    lHeight = ddsdOriginal.lHeight
    dblRMax = Sqr(lWidth ^ 2 + lHeight ^ 2)
    surfSource.Lock rEmpty, ddsdOriginal, DDLOCK_WAIT, 0
    surfDestination.GetSurfaceDesc ddsdDestination
    surfDestination.Lock rEmpty2, ddsdDestination, DDLOCK_WAIT, 0
    
    XDest = XDest + lWidth / 2
    Ydest = Ydest + lHeight / 2
    For iX = -dblRMax To dblRMax
        For iY = -dblRMax To dblRMax
            lngXO = lWidth / 2 - (iX * CosA + iY * SinA)
            lngYO = lHeight / 2 - (iX * SinA - iY * CosA)
            If lngXO >= 0 Then
                If lngYO >= 0 Then
                    If lngXO < lWidth Then
                        If lngYO < lHeight Then
                            lngColor = surfSource.GetLockedPixel(lngXO, lngYO)
                            If rgbTransparency = -1 Or lngColor <> rgbTransparency Then
                                surfDestination.SetLockedPixel XDest + iX, Ydest + iY, lngColor
                            End If
                        End If
                    End If
                End If
            End If
        Next iY
    Next iX
    surfSource.Unlock rEmpty
    surfDestination.Unlock rEmpty2
    Width = lWidth / 2 - (iX * CosA + iY * SinA)
    Height = lHeight / 2 - (iX * SinA - iY * CosA)
End Function

Private Sub InitTables()
    Dim dSinTable As Double
    Dim iDegree As Integer, i As Integer
    Dim dRadian As Double
    
    For i = 0 To MAX_SINE - 1
        ' Make it a degree between 0 - 360
        iDegree = i * 4
        ' Convert degree to radian
        dRadian = iDegree * PI / 180
        ' Get the Sinus value
        dSinTable = Sin(dRadian)
        ' Multiply it with the upper limit
        sineTab(i) = CByte(dSinTable * (charMax.cy / 2) + (charMax.cy / 2))
    Next i
    
    For i = 0 To (MAX_SINE / 2) - 1
        sineTab1(i) = CByte((i / (MAX_SINE / 2)) * charMax.cy)
    Next i
    For i = MAX_SINE \ 2 To MAX_SINE ' - 1
        sineTab1(i) = CByte(((MAX_SINE - i) / (MAX_SINE / 2)) * charMax.cy)
    Next i

    For i = 0 To MAX_SINE - 1
        ' Make it a degree between 0 - 360
        iDegree = i * 2
        ' Convert degree to radian
        dRadian = iDegree * PI / 180
        ' Get the Sinus value
        dSinTable = Sin(dRadian)
        ' Multiply it with the upper limit
        sineTab2(i) = CByte(dSinTable * (charMax.cy / 2) + (charMax.cy / 2))
    Next i

    For i = 0 To MAX_SINE - 1
        sineTab3(i) = CByte(charMax.cy - sineTab2(i))
    Next i

    Dim x As Integer
    Dim c As Integer
    
    x = charMax.cy / MAX_SINE
    c = 0

    For i = 0 To MAX_SINE - 1
        sineTab4(i) = CByte(c)
        c = c + x
    Next i

    For i = 0 To MAX_SINE - 1
        sineTab5(i) = 0
    Next i
End Sub

